--
-- Swarm
-- Version: R 1.0.7.0
-- Author: Walkerbo
-- Date: Saturday, 24 September 2016
--

-- I have tried to name variables, functions, frames, and buttons to be more descriptive.

--===================	Metrics, Lists & Variables	 ============================
local addonName = "Swarm"
local versionNumber = "R 1.1.7.0"

local fontColour, buttonIcon = "|cff00ffff", "Interface\\TargetingFrame\\UI-RaidTargetingIcon_8.png"
local localLanguage, menuButtonText = GetLocale(), "SWARM "

-- This is my first attempt at localization    **crosses fingers**
if localLanguage == deDE then
	menuButtonText = "SCHWARM " -- German
	elseif 	localLanguage == esES then
	menuButtonText = "ENJAMBRE " -- Spanish (Spain)
	elseif 	localLanguage == esMX then
	menuButtonText = "ENJAMBRE " -- Spanish (Latin America)
	elseif 	localLanguage == frFR then
	menuButtonText = "ESSAIM " -- French
	elseif 	localLanguage == itIT then
	menuButtonText = "SCIAME " -- Italian
	elseif 	localLanguage == ptBR then
	menuButtonText = "ENXAME " -- Brazilian Portuguese
	elseif 	localLanguage == ruRU then
	menuButtonText = "РОЙ " -- Russian
	elseif 	localLanguage == koKR then
	menuButtonText = "메뚜기 떼 " -- Korean
	elseif 	localLanguage == zhCN then
	menuButtonText = "群 " -- Simplified Chinese
	elseif localLanguage == zhTW then
	menuButtonText = "群 " -- Traditional Chinese
end 

-- List of the target menus that I will add the swarm button too
local targetMenuList = {
	"PLAYER",
	"RAID_PLAYER",
	"PARTY",
	"TARGET",
	"FRIEND",
}

-- The swarm menu button
UnitPopupButtons["SWARM_MENU_BUTTON"] = {text = fontColour..menuButtonText, dist = 0, icon = buttonIcon}

-- Add a seperator, the swarm button and another seperator to each right click target menu
for k,v in pairs(targetMenuList) do	
	table.insert(UnitPopupMenus[v],"SUBSECTION_SEPARATOR")
	table.insert(UnitPopupMenus[v],"SWARM_MENU_BUTTON")
	table.insert(UnitPopupMenus[v],"SUBSECTION_SEPARATOR")	
end

-- The swarm function 
local function SwarmButtonFunction(self)
	if self.value == "SWARM_MENU_BUTTON" and UnitIsDead("target")~= true then -- If button is there and target is alive 
		SetRaidTarget("target", 0) -- Clear any raid target markers
		SetRaidTarget("target", 8) -- Apply skull raid target marker 
		local chatString = ((UnitName("target")).."  :  "..(math.floor(UnitHealth("target") / UnitHealthMax("target") * 100)).."%") -- Get target name and health 
		SendChatMessage(chatString, "CHANNEL", nil, 1) -- Sent to general chat
		local playerXLoc, playerYLoc = GetPlayerMapPosition("player") -- Get player location 
		chatString = ((format("%s %s :  %.1f, %.1f",GetZoneText(),GetSubZoneText(),playerXLoc*100,playerYLoc*100))) -- Over write previous string with the player location 
		SendChatMessage(chatString, "CHANNEL", nil, 1) -- Send to chat 
	end
end

-- Hook the target right click menu function  
hooksecurefunc("UnitPopup_OnClick", SwarmButtonFunction)